﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;
namespace PAT.Lib
{
    class DeviceBase : ExpressionValue
    {

        public DeviceBase()
        {
        }

        public DeviceBase(DeviceBase obj)
        {

        }

        public virtual void reset()
        {

        }

        public virtual GDBase read(int offset)
        {
            return Value.Error();
        }

        public virtual void write(int offset, GDBase gd)
        {
            
        }

        public virtual int size()
        {
            return 0;
        }
        
        
        public override string ToString()
        {
            return ExpressionID ;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public virtual DeviceBase clone()
        {
            return new DeviceBase(this);
        }

        public override string ExpressionID
        {
            get
            {
                return "DeviceBase";
            }
        }
    }
}
