﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class Mem : GDBase
    {
        int _address = -1;
        public int adr
        {
            get { return _address; }
            set { _address = value; }
        }

        public Mem()
        {
        }

        public Mem(Mem obj)
        {
            _address = obj._address;
        }

        public Mem(int value)
        {
            adr = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new Mem(this);
        }

        public override string ToString()
        {
            return ExpressionID;
        }

        public override string ExpressionID
        {
            get
            {
                return typeString() + "(" + adr.ToString() + ")";
            }
        }

        public override string typeString()
        {
            return "m";
        }
    }
}
