﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class Reg : GDBase
    {
        int _index = -1;
        public int idx
        {
            get { return _index; }
            set { _index = value; }
        }
        public Reg()
        {
        }

        public Reg(Reg obj)
        {
            _index = obj._index;
        }

        public Reg(int value)
        {
            idx = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new Reg(this);
        }

        public override string ToString()
        {
            return ExpressionID;
        }

        public override string ExpressionID
        {
            get
            {
                return typeString() + "(" + idx.ToString() + ")";
            }
        }

        public override string typeString()
        {
            return "r";
        }
    }
}
