﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class SKey : GDBase
    {
        int _id = -1;
        public int id
        {
            get { return _id; }
            set { _id = value; }
        }
        public SKey()
        {
        }

        public SKey(SKey obj)
        {
            _id = obj._id;
        }

        public SKey(int value)
        {
            id = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new SKey(this);
        }

        public override string ToString()
        {
            return ExpressionID;
        }

        public override string ExpressionID
        {
            get
            {
                return typeString() + "(" + id.ToString() + ")";
            }
        }

        public override string typeString()
        {
            return "sk";
        }
    }
}
