﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class GDBase : ExpressionValue,IEquatable<GDBase>
    {
        public GDBase()
        {
        }

        public GDBase(GDBase obj)
        {
        }

        public override string ToString()
        {
            return "";
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public virtual GDBase clone()
        {
            return new GDBase(this);
        }

        public virtual string typeString()
        {
            return "";
        }

        private List<GDBase> sameType(List<GDBase> k)
        {
            List<GDBase> ret = new List<GDBase>();
            foreach (GDBase obj in k)
            {
                if (obj.typeString() == typeString())
                    ret.Add(obj);
            }
            return ret;
        }

        private List<GDBase> sameContent(List<GDBase> k)
        {
            List<GDBase> ret = new List<GDBase>();
            foreach (GDBase obj in k)
            {
                if (obj.ExpressionID == ExpressionID)
                    ret.Add(obj);
            }
            return ret;
        }

        //TODO: move to knowledge
        /*
        public void deduplicate(List<GDBase> k)
        {

        }
        */
        public virtual List<GDBase> generate(List<GDBase> k)
        {
            return sameType(k);
        }

        public virtual bool duplicate(List<GDBase> k)
        {
            bool ret = false;
            foreach (GDBase obj in k)
            {
                if (obj.ExpressionID == ExpressionID)
                {
                    ret = true;
                }
            }
            return ret;
        }

        public override string ExpressionID
        {
            get
            {
                return "";
            }
        }

        public bool Equals(GDBase other)
        {
            if (other == null) return false;
            if (ExpressionID == other.ExpressionID)
                return true;
            else
                return false;
        }
    }
}
