﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class RIP : GDBase
    {
        int _offset = -1;
        public int offset
        {
            get { return _offset; }
            set { _offset = value; }
        }

        public RIP()
        {
        }

        public RIP(RIP obj)
        {
            _offset = obj._offset;
        }

        public RIP(int value)
        {
            _offset = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new RIP(this);
        }

        public override string ToString()
        {
            return ExpressionID;
        }

        public override string ExpressionID
        {
            get
            {
                return typeString() + "(" + offset.ToString() + ")";
            }
        }

        public override string typeString()
        {
            return "rip";
        }
    }
}
