﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class Value : GDBase
    {
        int _value = -1;
        bool _error = false;

        public int v
        {
            get 
            {
                if (!_error)
                    return _value;
                else
                    //return -1;
                    throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("Value: error value");
            }
            set { _value = value; }
        }

        public Value()
        {
        }

        public Value(Value obj)
        {
            _value = obj._value;
            _error = obj._error;
        }

        public Value(int value)
        {
            v = value;
        }

        public static Value Error()
        {
            Value v=new Value();
            v._error = true;
            return v;
        }

        public bool isError { get { return _error; } }
                
        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new Value(this);
        }

        public override string ToString()
        {
            return ExpressionID;
        }

        public override string ExpressionID
        {
            get
            {
                if (!_error)
                    return "v(" + v.ToString() + ")";
                else
                    return "v(e)";
            }
        }

        public override string typeString()
        {
            return "value";
        }

        
       
    }
}
